MODULE PMModule
   ! Latest revisions by MCN on February 9, 2009
   USE GlobalModule                                                  ! Compile this module first
   USE UtilityModule                                                 ! Compile this module first
   INTEGER(KIND=IK), PARAMETER :: NUM_VT_AGES = 6                    ! Number of tidal volume age bins
   INTEGER(KIND=IK), PARAMETER :: NUM_FILTERS  = 9                   ! # effective mass filters in model    
   REAL(KIND=RK),    PARAMETER :: MFP=0.0000712                      ! Mean free path of air at 37C, cm
   REAL(KIND=RK),    PARAMETER :: KBOLTZ=1.38E-19                    ! Boltzmanns const kgcm^2/s^2K
   REAL(KIND=RK),    PARAMETER :: MU=0.0000019                       ! Absolute visc of air at 37C, kg/cm-sec  
   REAL(KIND=RK),    PARAMETER :: T=310.15                           ! Body temp (37C) in Kelvin   
   REAL     (KIND=RK)  :: VT_ages(NUM_VT_AGES)=                     & 
      (/0.333, 1., 5., 10., 15., 30./)                               ! Vector of ages for estimating TV

   TYPE :: FEMALESUB                                                 ! Structure of female vent. inputs
      REAL(KIND=RK) :: A_S1       =   1.2800E-04                     ! Regres. coef.: scaling factor S1       
      REAL(KIND=RK) :: B_S1       =   -4.3542E-02                    ! Regres. coef.: scaling factor S1
      REAL(KIND=RK) :: C_S1       =   4.7975E+00                     ! Regres. coef.: scaling factor S1
      REAL(KIND=RK) :: A_S2       =   2.3200E-05                     ! Regres. coef.: scaling factor S2      
      REAL(KIND=RK) :: B_S2       =   1.1225E-02                     ! Regres. coef.: scaling factor S2          
      REAL(KIND=RK) :: C_S2       =   2.2597E+00                     ! Regres. coef.: scaling factor S2        
      REAL(KIND=RK) :: A_S3       =   8.0500E-05                     ! Regres. coef.: scaling factor S3 
      REAL(KIND=RK) :: B_S3       =  -3.2543E-02                     ! Regres. coef.: scaling factor S3          
      REAL(KIND=RK) :: C_S3       =   4.2585E+00                     ! Regres. coef.: scaling factor S3                 
      REAL(KIND=RK) :: A_FRC      =   0.222                          ! Regres. coef.: FRC                
      REAL(KIND=RK) :: B_FRC      =  -26.483                         ! Regres. coef.: FRC 	 	            
      REAL(KIND=RK) :: C_FRC      =   959.95                         ! Regres. coef.: FRC 		            
      REAL(KIND=RK) :: A_VD       =   0.0079                         ! Regres. coef.: dead space 	
      REAL(KIND=RK) :: B_VD       =  -0.7403                         ! Regres. coef.: dead space 	               
      REAL(KIND=RK) :: C_VD       =   30.381                         ! Regres. coef.: dead space 	                 
      REAL(KIND=RK) :: A_VDET     =   0.0029                         ! Regres. coef.: dead space, et 	               
      REAL(KIND=RK) :: B_VDET     =  -0.2861                         ! Regres. coef.: dead space, et          
      REAL(KIND=RK) :: C_VDET     =   9.5306                         ! Regres. coef.: dead space, et                          
      REAL(KIND=RK) :: A_VDTB     =   0.0022                         ! Regres. coef.: dead space, tb                
      REAL(KIND=RK) :: B_VDTB     =  -0.1523                         ! Regres. coef.: dead space, tb                
      REAL(KIND=RK) :: C_VDTB     =   5.9635                         ! Regres. coef.: dead space, tb               
      REAL(KIND=RK) :: A_VDB      =   0.0029                         ! Regres. coef.: dead space, bronch 
      REAL(KIND=RK) :: B_VDB      =  -0.3225                         ! Regres. coef.: dead space, bronch 	               
      REAL(KIND=RK) :: C_VDB      =   16.098                         ! Regres. coef.: dead space, bronch                                         
      REAL(KIND=RK)  :: VT_0(NUM_VT_AGES)=                          & 
         (/39, 74, 174, 304, 417, 444/)                              ! Tidal volumes at activity=0 
      REAL     (KIND=RK)  :: VT_1(NUM_VT_AGES)=                     &   
         (/66, 102, 213, 333, 417, 464/)                             ! Tidal volumes at activity=1
      REAL     (KIND=RK)  :: VT_2(NUM_VT_AGES)=                     &
         (/66, 127, 244, 583, 903, 992/)                             ! Tidal volumes at activity=2
      REAL     (KIND=RK)  :: VT_3(NUM_VT_AGES)=                     &
         (/66, 127, 244, 667, 1127, 1364/)                           ! Tidal volumes at activity=3
   END TYPE FEMALESUB                                                ! End female ventilatory inputs                                     
 
   TYPE :: MALESUB                                                   ! Structure of male vent. inputs
      REAL(KIND=RK) :: A_S1       =   1.1354E-04                     ! Regres. coef.: scaling factor S1 
      REAL(KIND=RK) :: B_S1       =  -4.0700E-02                     ! Regres. coef.: scaling factor S1
      REAL(KIND=RK) :: C_S1       =  4.6711E+00                      ! Regres. coef.: scaling factor S1
      REAL(KIND=RK) :: A_S2       =  2.3020E-05                      ! Regres. coef.: scaling factor S2
      REAL(KIND=RK) :: B_S2       = -1.1168E-02                      ! Regres. coef.: scaling factor S2
      REAL(KIND=RK) :: C_S2       =  2.2567E+00                      ! Regres. coef.: scaling factor S2
      REAL(KIND=RK) :: A_S3       =   7.8360E-05                     ! Regres. coef.: scaling factor S3                 
      REAL(KIND=RK) :: B_S3       =  -3.2100E-02                     ! Regres. coef.: scaling factor S3
      REAL(KIND=RK) :: C_S3       =  4.2381E+00                      ! Regres. coef.: scaling factor S3                      
      REAL(KIND=RK) :: A_FRC      =  0.2278                          ! Regres. coef.: FRC 		
      REAL(KIND=RK) :: B_FRC      = -27.95                           ! Regres. coef.: FRC                
      REAL(KIND=RK) :: C_FRC      =  1035.3                          ! Regres. coef.: FRC                  
      REAL(KIND=RK) :: A_VD       =  0.0078                          ! Regres. coef.: dead space 
      REAL(KIND=RK) :: B_VD       = -0.7135                          ! Regres. coef.: dead space 	                 
      REAL(KIND=RK) :: C_VD       =  29.316                          ! Regres. coef.: dead space                                            
      REAL(KIND=RK) :: A_VDET     =  0.0031                          ! Regres. coef.: dead space, et 
      REAL(KIND=RK) :: B_VDET     = -0.3175                          ! Regres. coef.: dead space, et                
      REAL(KIND=RK) :: C_VDET     =  10.907                          ! Regres. coef.: dead space, et                          
      REAL(KIND=RK) :: A_VDTB     =  0.0026                          ! Regres. coef.: dead space, tb               
      REAL(KIND=RK) :: B_VDTB     = -0.2392                          ! Regres. coef.: dead space, tb                 
      REAL(KIND=RK) :: C_VDTB     =  9.7143                          ! Regres. coef.: dead space, tb                 
      REAL(KIND=RK) :: A_VDB      =  0.0023                          ! Regres. coef.: dead space, bronch 
      REAL(KIND=RK) :: B_VDB      = -0.2119                          ! Regres. coef.: dead space, bronch                 
      REAL(KIND=RK) :: C_VDB      =  11.375                          ! Regres. coef.: dead space, bronch                                                                           
      REAL(KIND=RK)  :: VT_0(NUM_VT_AGES)=                          &        
         (/39, 74, 174, 304, 500, 625/)                              ! Tidal volumes at activity=0 
      REAL     (KIND=RK)  :: VT_1(NUM_VT_AGES)=                     &
         (/66, 102, 213, 333, 533, 750/)                             ! Tidal volumes at activity=1 
      REAL     (KIND=RK)  :: VT_2(NUM_VT_AGES)=                     &
         (/66, 127, 244, 583, 1000, 1250/)                           ! Tidal volumes at activity=2 
      REAL     (KIND=RK)  :: VT_3(NUM_VT_AGES)=                     &
         (/66, 127, 244, 841, 1352, 1923/)                           ! Tidal volumes at activity=3 
   END TYPE MALESUB                                                  ! End female ventilatory inputs   

   TYPE (MALESUB)         :: M                                       ! Define a male vent. structure
   TYPE (FEMALESUB)       :: F                                       ! Define a female vent. structure
   REAL     (KIND=RK)     :: FRC=0                                   ! Functional residual capacity                   
   REAL     (KIND=RK)     :: Vt=0                                    ! Tidal volume 
   REAL     (KIND=RK)     :: Vd=0                                    ! Dead space 
   REAL     (KIND=RK)     :: Vd_et=0                                 ! Dead space, extrathoracic 
   REAL     (KIND=RK)     :: Vd_tb=0                                 ! Dead space, tracheobr.  
   REAL     (KIND=RK)     :: Vd_b=0                                  ! Dead space, bronchial  
   REAL     (KIND=RK)     :: Vdot=0                                  ! Total inspiratory flow rate  
   REAL     (KIND=RK)     :: Vdot_n=0                                ! Nasal flow rate  
   REAL     (KIND=RK)     :: Vdot_m=0                                ! Oral (mouth) flow rate
   REAL     (KIND=RK)     :: PctNasal=0                              ! Percent of Vdot to nose  
   REAL     (KIND=RK)     :: PctOral=0                               ! Percent of Vdot to mouth 
   REAL     (KIND=RK)     :: T_tb=0                                  ! Residence time in TB 
   REAL     (KIND=RK)     :: T_b=0                                   ! Residence time in bronch  
   REAL     (KIND=RK)     :: T_a=0                                   ! Residence time in alveolated  
   REAL     (KIND=RK)     :: Height=0                                ! Height
   REAL     (KIND=RK)     :: Age=0                                   ! Age
   REAL     (KIND=RK)     :: S1=0                                    ! Age scaling factor 1
   REAL     (KIND=RK)     :: S2=0                                    ! Age scaling factor 2
   REAL     (KIND=RK)     :: S3=0                                    ! Age scaling factor 3
   REAL     (KIND=RK)     :: Density=1                               ! Density    
   REAL     (KIND=RK)     :: D=0                                     ! Diffusion coefficient    
   REAL     (KIND=RK)     :: ADia=0                                  ! Aerodynamic Diameter, microns 
   REAL     (KIND=RK)     :: ADia_cm=0                               ! Aerodynamic Diameter, cm 
   REAL     (KIND=RK)     :: TDia=0                                  ! Thermodynamic Diameter,microns    
   REAL     (KIND=RK)     :: TDia_cm=0                               ! Thermodynamic Diameter,microns    
   REAL     (KIND=RK)     :: Cc_ae                                   ! Slip corr factor, aerodynam dia    
   REAL     (KIND=RK)     :: Cc_th                                   ! Slip corr factor, themodynam dia
   REAL     (KIND=RK)     :: FInh                                    ! Inhalable fraction
   REAL     (KIND=RK)     :: Fn                                      ! Nose deposition fraction
   REAL     (KIND=RK)     :: Fo                                      ! Oropharyngeal deposition fraction
   REAL     (KIND=RK)     :: FtbInh                                  ! Tracheobroch_inh deposition fraction
   REAL     (KIND=RK)     :: FtbExh                                  ! Tracheobroch_exh deposition fraction
   REAL     (KIND=RK)     :: Fb                                      ! Bronchiole deposition fraction
   REAL     (KIND=RK)     :: Fa                                      ! Alveoli deposition fraction
   REAL     (KIND=RK)     :: MassToLung                              ! Alveoli deposition fraction
   REAL     (KIND=RK)     :: DepN                                    ! Dep mass for current size, nose
   REAL     (KIND=RK)     :: DepO                                    ! Dep mass for current size, oral
   REAL     (KIND=RK)     :: DepTB                                   ! Dep mass for current size, TB
   REAL     (KIND=RK)     :: DepB                                    ! Dep mass for current size, B
   REAL     (KIND=RK)     :: DepA                                    ! Dep mass for current size, A
   REAL     (KIND=RK)     :: DepTotal                                ! Total dep mass for current size
   REAL     (KIND=RK)     :: TimeExposed                             ! Exposure Time    
   REAL     (KIND=RK)     :: AmbientConc, VentRate                   ! Ambient Concentration    
   REAL     (KIND=RK)     :: InhaledMass                             ! Inhaled mass 
   REAL     (KIND=RK), ALLOCATABLE :: Duration(:)                    ! Duration of event 
   REAL     (KIND=RK), ALLOCATABLE :: DepMassTotal(:)                ! Inhaled mass 
   REAL     (KIND=RK), ALLOCATABLE :: DepMassN(:)                    ! Deposited mass, nose 
   REAL     (KIND=RK), ALLOCATABLE :: DepMassO(:)                    ! Deposited mass, oropharynx 
   REAL     (KIND=RK), ALLOCATABLE :: DepMassTB(:)                   ! Deposited mass, tracheobronchial 
   REAL     (KIND=RK), ALLOCATABLE :: DepMassB(:)                    ! Deposited mass, bronchioles 
   REAL     (KIND=RK), ALLOCATABLE :: DepMassA(:)                    ! Deposited mass, alveoli 
   REAL     (KIND=RK), ALLOCATABLE :: Sizes(:)                       ! Particle sizes (Diameters)
   REAL     (KIND=RK), ALLOCATABLE :: MassFrac(:)                    ! Particle mass fractions
   INTEGER  (KIND=IK)  :: J=0, K=0                                   ! Event and part size indices
   INTEGER  (KIND=IK)  :: NormalizeToTrachea=NO                      ! Normalize to mass entering trachea
   INTEGER  (KIND=IK)  :: ActivityLevel=0                            ! Level of activity (0-3) 
   INTEGER  (KIND=IK)  :: Gender=MALE                                ! Gender
   INTEGER  (KIND=IK)  :: NEvents                                    ! Number of diary events
   INTEGER  (KIND=IK)  :: NumSizes=0                                 ! Number of particle sizes

CONTAINS

SUBROUTINE PMDose(P,PL)                                              ! Called from Dose      
   INTEGER  (KIND=IK)     :: P, PL                                   ! Person, pollutant
   INTEGER  (KIND=IK)     :: F                                       ! Filter index
   REAL(Kind=IK) a_ae_n,R_ae_n,p_ae_n,a_th_n,R_th_n,p_th_n           ! Local variables      
   REAL(Kind=IK) a_ae_on,R_ae_on,p_ae_on,a_th_on,R_th_on,p_th_on     ! Local variables   
   REAL(Kind=IK) a_ae_oo,R_ae_oo,p_ae_oo,a_th_oo,R_th_oo,p_th_oo     ! Local variables   
   REAL(Kind=IK) a_ae_tb_inh, a_ae_tb_exh                            ! Local variables    
   REAL(Kind=IK) R_ae_tb,p_ae_tb,a_th_tb,R_th_tb,p_th_tb             ! Local variables   
   REAL(Kind=IK) a_ae_b,R_ae_b,p_ae_b,a_th_b,R_th_b,p_th_b           ! Local variables   
   REAL(Kind=IK) a_ae_a,R_ae_a,p_ae_a,a_th_a,R_th_a,p_th_a           ! Local variables   
   REAL(Kind=IK) f_ae_n, f_th_n                                      ! Local variables   
   REAL(Kind=IK) f_ae_on, f_th_on, f_ae_oo, f_th_oo, f_ae_o, f_th_o  ! Local variables   
   REAL (KIND=RK) :: cum_mass,  TotalInh                             ! Cumulative mass   
   REAL (KIND=RK) :: mass(NUM_FILTERS), depfrac(NUM_FILTERS)         ! Loc vars for mass and dep frac 
   REAL (KIND=RK) :: TotalF=0, DepET=0, DepTBtot=0, DepP=0, DepT=0   ! Local variables
   REAL (KIND=RK) :: DepETHum=0, DepTBHum=0, DepPHum=0, DepTHum=0    ! Local variables
   REAL (KIND=RK) :: M                                               ! Normalized METS   
   NEvents = NumEvents                                               ! Set num events
   Gender  = Person(p)%Gender                                        ! Set gender
   Height  = Phys(p)%Height*2.54                                     ! Set height (convert to cm)
   Age     = Person(p)%Age                                           ! Set age (years)
   CALL LungProperties                                               ! Properties constant for profile  
   DO K=1, NEvents                                                   ! Loop over events  
      VentRate      = EventSeq(K)%VE/60.							 ! Ventilation rate ml/s	
      TimeExposed   = EventSeq(K)%Duration*60.                       ! Duration of PM exposure (s)
      Vdot          = EventSeq(K)%VE/30.                             ! Convert to insp rate ml/s  
      Conc          = EventSeq(K)%Exposure*.000001                   ! PM concentration ug/ml  
      M=(EventSeq(K)%Mets-1)/(Phys(P)%MetsMax-1)                     ! Normalized METS
      IF (M <= 0) THEN                                               ! If METS indicates sleep
         ActivityLevel = 0                                           ! Set other act levels via METS val   
      ELSE IF (M > 0 .AND. M <= 0.333) THEN                          ! Otherwise  
         ActivityLevel = 1                                           ! Sitting   
      ELSE IF (M > 0.333 .AND. M <= 0.667) THEN                      ! Otherwise  
         ActivityLevel = 2                                           ! Light exercise
      ELSE                                                           ! Otherwise  
         ActivityLevel = 3                                           ! Heavy exercise
      ENDIF                                                          ! End of activity logic           
      FInh=1-0.5*(1-(1/(0.00076*Pol(PL)%Size**2.8+1)))               ! Inhalable fraction assuming U=0
      InhaledMass=FInh*TimeExposed*VentRate*Conc                     ! Inhaled mass 
      CALL VentilationVariables                                      ! Calculate activity dependent vars
      TotalInh=0													 ! Init. inhaled mass			 
      DepET=0														 ! Init. ET mass
      DepTBtot=0													 ! Init. TB mass
      DepP=0														 ! Init. P mass
      DepT=0														 ! Init. Tot mass
      DepETHum=0													 ! Init. ET humtr mass
      DepTBHum=0													 ! Init. TB humtr mass
      DepPHum=0														 ! Init. P humtr mass
      DepTHum=0														 ! Init. Tot humtr mass
      ADia=Pol(PL)%Size                                              ! Set the aerodynamic diameter
      ADia_cm=ADia/10000                                             ! Aero diameter in cm
      D=DiffCoeff(ADia_cm)                                           ! Calculate diffusion coeff   
      a_ae_n          =   3E-4                                       ! a for aero dep, nose
      R_ae_n          =   (ADia**2)*Vdot_n*(S1**3)                   ! R for aero dep, nose
      p_ae_n          =   1                                          ! p for aero dep, nose
      a_th_n          =   18                                         ! a for therm dep, nose
      R_th_n          =   D*(Vdot_n*S1)**-0.25                       ! R for therm dep, nose
      p_th_n          =   0.5                                        ! p for therm dep, nose
      a_ae_on         =   5.5E-5                                     ! a for aero dep, oroph, nose vent
      R_ae_on         =  (ADia**2)*Vdot_n*(S1**3)                    ! R for aero dep, oroph, nose vent
      p_ae_on         =   1.17                                       ! p for aero dep, oroph, nose vent
      a_th_on         =   15.1                                       ! a for therm dep, oroph, nose vent
      R_th_on         =   D*(Vdot_n*S1)**-0.25                       ! R for therm dep, oroph, nose vent
      p_th_on         =   0.538                                      ! p for therm dep, oroph, nose vent
      a_ae_oo         =   1.1E-4                                     ! a for aero dep, oroph, mouth vent
      R_ae_oo         =   (ADia**2)*((Vdot*S1**3)**0.6)*            &
                          ((Vt*S1**2)**-0.2)                         ! R for aero dep, oroph, mouth vent
      p_ae_oo         =   1.4                                        ! p for aero dep, oroph, mouth vent
      a_th_oo         =   9                                          ! a for therm dep, oroph, mouth vent
      R_th_oo         =   D*(Vdot_n*S1)**-0.25                       ! R for therm dep, oroph, mouth vent
      p_th_oo         =   0.5                                        ! p for therm dep, oroph, mouth vent
      a_ae_tb_inh     =   4.08E-6                                    ! a for aero dep, tb, inhalation
      a_ae_tb_exh     =   2.04E-6                                    ! a for aero dep, tb, exhalation
      R_ae_tb         =   (ADia**2)*Vdot*(S1**2.3)                   ! R for aero dep, tb 
      p_ae_tb         =   1.152                                      ! p for aero dep, tb 
      a_th_tb         =   22.02*(S1**1.24)*C                         ! a for therm dep, tb
      C               =   1+100*exp                                 &
                          (-1*(log10(100+(10/TDia**0.9)))**2)        ! C term for previous eq
      R_th_tb         =   D*T_tb                                     ! R for therm dep, tb 
      p_th_tb         =   0.6391                                     ! p for therm dep, tb 
      a_ae_b          =   0.1147                                     ! a for aero dep, b
      R_ae_b          =   (0.056+T_b**1.5)*(ADia**(T_b**(-0.25)))    ! R for aero dep, b
      p_ae_b          =   1.173                                      ! p for aero dep, b
      a_th_b          =   -76.8+167*(S2**0.65)                       ! a for therm dep, b
      R_th_b          =   D*T_b                                      ! R for therm dep, b
      p_th_b          =   0.5676                                     ! p for therm dep, b
      a_ae_a          =   0.146*S3**0.98                             ! a for aero dep, alveoli
      R_ae_a          =   (ADia**2)*T_a                              ! R for aero dep, alveoli
      p_ae_a          =   0.6495                                     ! p for aero dep, alveoli
      a_th_a          =   170+103*(S3**2.13)		                 ! R for therm dep, alveoli
      R_th_a          =   D*T_a                                      ! R for therm dep, alveoli
      p_th_a          =   0.6101                                     ! p for therm dep, alveoli
      f_ae_n          =   1-exp(-1*a_ae_n*R_ae_n**p_ae_n)            ! Aero dep frac for N 
      f_th_n          =   1-exp(-1*a_th_n*R_th_n**p_th_n)            ! Thermo dep frac for N
      Fn              =   sqrt(f_ae_n**2+f_th_n**2)                  ! Total N deposition frac
      f_ae_on         =   1-exp(-1*a_ae_on*R_ae_on**p_ae_on)         ! Aero dep frac for O, nasal vent   
      f_th_on         =   1-exp(-1*a_th_on*R_th_on**p_th_on)         ! Aero dep frac for O, oral vent  
      f_ae_oo         =   1-exp(-1*a_ae_oo*R_ae_oo**p_ae_oo)         ! Thermo dep frac for O, nasal vent 
      f_th_oo         =   1-exp(-1*a_th_oo*R_th_oo**p_th_oo)         ! Thermo dep frac for O, oral vent
      f_ae_o          =   PctNasal*f_ae_on+PctOral*f_ae_oo           ! Total aero dep frac for O
      f_th_o          =   PctNasal*f_th_on+PctOral*f_th_oo           ! Total thermo dep frac for O
      Fo              =   sqrt(f_ae_o**2+f_th_o**2)                  ! Total O deposition frac
      f_ae_tb_inh     =   1-exp(-1*a_ae_tb_inh*R_ae_tb**p_ae_tb)     ! Aero dep frac for TB, inh
      f_ae_tb_exh     =   1-exp(-1*a_ae_tb_exh*R_ae_tb**p_ae_tb)     ! Aero dep frac for TB, exh
      f_th_tb         =   1-exp(-1*a_th_tb*R_th_tb**p_th_tb)         ! Thermo dep frac for TB
      FtbInh          =   sqrt(f_ae_tb_inh**2+f_th_tb**2)            ! Total TB deposition frac, inh
      FtbExh          =   sqrt(f_ae_tb_exh**2+f_th_tb**2)            ! Total TB deposition frac, exh          
      f_ae_b          =   1-exp(-1*a_ae_b*R_ae_b**p_ae_b)            ! Aero dep frac for B 
      f_th_b          =   1-exp(-1*a_th_b*R_th_b**p_th_b)            ! Thermo dep frac for B
      Fb              =   sqrt(f_ae_b**2+f_th_b**2)                  ! Total B deposition frac
      f_ae_a          =   1-exp(-1*a_ae_a*R_ae_a**p_ae_a)            ! Aero dep frac for A 
      f_th_a          =   1-exp(-1*a_th_a*R_th_a**p_th_a)            ! Thermo dep frac for A
      Fa              =   sqrt(f_ae_a**2+f_th_a**2)                  ! Total A deposition frac
      depfrac(1) = Fn                                                ! Filter 1 is nose, inhale
      depfrac(2) = Fo                                                ! Filter 2 is oroph, inhale
      depfrac(3) = FtbInh                                            ! Filter 3 is tb, inhale
      depfrac(4) = Fb                                                ! Filter 4 is bronch, inhale
      depfrac(5) = Fa                                                ! Filter 5 is alveoli
      depfrac(6) = Fb                                                ! Filter 6 is bronch, exhale
      depfrac(7) = FtbExh                                            ! Filter 7 is tb, exhale 
      depfrac(8) = Fo                                                ! Filter 8 is oroph, exhale 
      depfrac(9) = Fn                                                ! Filter 9 is nose, exhale 
      cum_mass = 0                                                   ! Initialize cumulative mass
      DO F=1,NUM_FILTERS                                             ! Loop over filters
         mass(F) = depfrac(F)*(InhaledMass-cum_mass)                 ! Mass deposited in each filt
         cum_mass = cum_mass+mass(F)                                 ! Cumulative deposited mass
      ENDDO                                                          ! End filter loop
      DepN        = mass(1)+mass(9)                                  ! Total nose deposition 
      DepO        = mass(2)+mass(8)                                  ! Total oroph deposition 
      DepTB       = mass(3)+mass(7)                                  ! Total tb deposition  
      DepB        = mass(4)+mass(6)                                  ! Total bronch deposition 
      DepA        = mass(5)                                          ! Alveolar deposition 
      EventSeq(K)%DepDose  = DepN+DepO+DepTB+DepB+DepA               ! Total deposited mass 
      EventSeq(K)%IntakeDose  = InhaledMass/EventSeq(K)%Duration     ! Intake dose rate (ug/min)
      EventSeq(K)%Dose  = (DepN+DepO+DepTB+DepB+DepA)/              &
         EventSeq(K)%Duration                                        ! Deposited dose rate (ug/min) 
      EventSeq(K)%FDose = EventSeq(K)%Dose                           ! Final dose is same as event dose ***
   ENDDO                                                             ! End of event loop
END SUBROUTINE PMDose                                                ! Return to calling routine

SUBROUTINE LungProperties                                            ! Called from CalculateDeposition  
   IF (Gender == MALE) THEN                                          ! If person is male  
      S1       =   Poly2(M%A_S1,M%B_S1,M%C_S1,Height)                ! Scaling factor #1
      S2       =   Poly2(M%A_S2,M%B_S2,M%C_S2,Height)                ! Scaling factor #2
      S3       =   Poly2(M%A_S3,M%B_S3,M%C_S3,Height)                ! Scaling factor #3
      FRC      =   Poly2(M%A_FRC,M%B_FRC,M%C_FRC,Height)             ! Functional residual capacity
      Vd       =   Poly2(M%A_VD,M%B_VD,M%C_VD,Height)                ! Dead space
      Vd_et    =   Poly2(M%A_VDET,M%B_VDET,M%C_VDET,Height)          ! Extrathoracic dead space
      Vd_tb    =   Poly2(M%A_VDTB,M%B_VDTB,M%C_VDTB,Height)          ! TB dead space
      Vd_b     =   Poly2(M%A_VDB,M%B_VDB,M%C_VDB,Height)             ! B dead space
   ENDIF                                                             ! End male logic
   IF (Gender == FEMALE) THEN                                        ! If person is female  
      S1       =   Poly2(F%A_S1,F%B_S1,F%C_S1,Height)                ! Scaling factor #1
      S2       =   Poly2(F%A_S2,F%B_S2,F%C_S2,Height)                ! Scaling factor #2
      S3       =   Poly2(F%A_S3,F%B_S3,F%C_S3,Height)                ! Scaling factor #3
      FRC      =   Poly2(F%A_FRC,F%B_FRC,F%C_FRC,Height)             ! Functional residual capacity
      Vd       =   Poly2(F%A_VD,F%B_VD,F%C_VD,Height)                ! Dead space
      Vd_et    =   Poly2(F%A_VDET,F%B_VDET,F%C_VDET,Height)          ! Extrathoracic dead space
      Vd_tb    =   Poly2(F%A_VDTB,F%B_VDTB,F%C_VDTB,Height)          ! TB dead space
      Vd_b     =   Poly2(F%A_VDB,F%B_VDB,F%C_VDB,Height)             ! B dead space
     ENDIF                                                           ! End female logic
END SUBROUTINE LungProperties                                        ! Return to calling routine

SUBROUTINE VentilationVariables                                      ! Called from CalculateDeposition
   REAL     (KIND=RK)     :: age1,age2, i=1                          ! Local vars
   REAL     (KIND=RK)     :: VTS(NUM_VT_AGES)                        ! Local array of volumes
   age2=7                                                            ! Initialize age index 1                         
   age1=0                                                            ! Initialize age index 2    
   IF (Gender == MALE) THEN                                          ! If person is male                            
      IF (ActivityLevel == 0) VTS = M%VT_0                           ! If sleeping, use VT_0
      IF (ActivityLevel == 1) VTS = M%VT_1                           ! If sitting, use VT_1
      IF (ActivityLevel == 2) VTS = M%VT_2                           ! If lgt ex, use VT_2
      IF (ActivityLevel == 3) VTS = M%VT_3                           ! If heavy ex, use VT_3
   ENDIF                                                             ! End male logic                                                               !   
   IF (Gender == FEMALE) THEN                                        ! If person is female                              
      IF (ActivityLevel == 0) VTS = F%VT_0                           ! If sleeping, use VT_0
      IF (ActivityLevel == 1) VTS = F%VT_1                           ! If sitting, use VT_1
      IF (ActivityLevel == 2) VTS = F%VT_2                           ! If lgt ex, use VT_2
      IF (ActivityLevel == 3) VTS = F%VT_3                           ! If heavy ex, use VT_3
   ENDIF                                                             ! End female logic
   DO i=1,6                                                          ! Loop over age bins
      IF (VT_AGES(i)>Age) THEN                                       ! If age bin greater than age
         age2=i                                                      ! Set high age to bin index            
         age1=i-1                                                    ! Set low age to previous bin
         EXIT                                                        ! Exit loop     
      ENDIF                                                          ! End if age bin>age
   ENDDO                                                             ! End loop over age bins
   IF (age2 == 7)  THEN                                              ! If age2=7, then age>max age
      Vt = VTS(6);                                                   ! Set age equal to max age
   ELSE IF (age2 == 1) THEN                                          ! If age2=1 then age<min age       
      Vt = VTS(1);                                                   ! Set age to min age
   ELSE                                                              ! Else age falls in bins range        
      Vt = VTS(age1)+												&		
	     ((Age-VT_AGES(age1))								        &
		 /(VT_AGES(age2)-VT_AGES(age1)))*					  		&
		 (VTS(age2)-VTS(age1))							             ! Linear interp of Vt from age   
   ENDIF                                                             ! End age cases
   IF (ActivityLevel == 0)  PctNasal = 1                             ! At sleep, all nasal
   IF (ActivityLevel == 1)  PctNasal = 1                             ! Sitting, all nasal
   IF (ActivityLevel == 2)  PctNasal = 1                             ! Light ex, all nasal
   IF (ActivityLevel == 3)  PctNasal = 0.5                           ! Heavy ex, 0.5 nasal
   PctOral     = (1-PctNasal)                                        ! Oral = 1-Nasal
   Vdot_n      = Vdot*PctNasal                                       ! Nasal flow rate 
   T_tb        = (Vd_tb/Vdot)*(1+(0.5*Vt/FRC))                       ! Residence time in TB region   
   T_b         = (Vd_b/Vdot)*(1+(0.5*Vt/FRC))                        ! Residence time in B region 
   T_a         = (Vt-Vd_et-(Vd_tb+Vd_b)*(1+Vt/FRC))/Vdot             ! Residence time in A region 
END SUBROUTINE VentilationVariables                                  ! Return to Deposition

REAL (KIND=RK) FUNCTION  DiffCoeff(dia_cm)                           ! Calculate diffusion coeff   
   REAL(KIND=RK) dia_cm, Cc                                          ! Local variables
   TDia_cm=ThermoDia(dia_cm)                                         ! Call Thermo diameter func
   Cc=1+(MFP/TDia_cm)*(2.514+0.8*exp(-0.55*(TDia_cm/MFP)))           ! Slip factor for dth
   DiffCoeff=(Cc*KBOLTZ*T)/(3*PI*MU*TDia_cm)                         ! Diffusion coefficient
   TDia=TDia_cm*10000                                                ! Thermo diameter in microns   
END FUNCTION DiffCoeff                                               ! Return to calling routine   

REAL (KIND=RK) FUNCTION Poly2(a,b,c,h)                               ! Polynomial function of height
   REAL (KIND=RK) :: a,b,c,h                                         ! Coefficients and height
   Poly2 = a*h**2+b*h+c                                              ! Calculate the parameter 
END FUNCTION Poly2                                                   ! Return to calling function 

REAL (KIND=RK) FUNCTION  ThermoDia(adia)                             ! Fixed-point iteration for ThermoDia
   REAL (KIND=RK) :: delta =.0000001, err=1, adia                    ! Local variables
   REAL (KIND=RK) :: Cc_ae, Cc_th                                    ! Slip factors for dth and dae
   Cc_ae=1+(MFP/adia)*(2.514+0.8*exp(-0.55*(adia/MFP)))              ! Calculate slip correction, aero
   ThermoDia_p=adia*SQRT(1.5/Density)                                ! Initial guess for ThermoDia    
   DO                                                                ! Iteratively calculate ThermoDia
      Cc_th=1+(MFP/ThermoDia_p)*                                    &
         (2.514+0.8*exp(-0.55*(ThermoDia_p/MFP)))                    ! Calculate slip correction, therm  
      ThermoDia=adia*sqrt((1.5/Density)*(CC_ae/CC_th))               ! Estimate thermoDia
      err=ThermoDia-ThermoDia_p                                      ! Calc error
      IF (err<delta) EXIT                                            ! Test convergence 
      ThermoDia_p=ThermoDia                                          ! Reset ThermoDia_p
   ENDDO                                                             ! End interation loop   
END FUNCTION                                                         ! Return to DiffCoeff function   

END MODULE PMModule                                                  ! End of DepositionModule code       